--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### June 24, 2008

#### File: attackChecks.lua
#### Description: attacks Checks and IDS Configuration functions

#### Revisions:
None
]]--


--************* Requires *************
require "teamf1lualib/fwRules"

--************* Initial Code *************
--package attackChecks
attackChecks = {}
attackChecks6 = {}
--************* Functions *************
-- attackChecks config
function attackChecks.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    
    db.beginTransaction() --begin transaction
    local valid = false

    -- validate

    DBTable = "AttackChecks"
    valid = fw.config(inputTable, rowid, operation)

    if (valid) then
        DBTable = "Igmp"
        valid = fw.config (inputTable, rowid, operation)

        --if (valid) then
          --  DBTable = "PowerModeConf"
            --valid = fw.config (inputTable, rowid, operation)
        --end
    end
    
    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "FW_AC_CONFIG_FAILED"
    end
end

-- attackChecks config
function attackChecks.configGet ()
    local outTable = {}
    local attackChecksConfig = db.getRow ("AttackChecks","_ROWID_","1")
    outTable = util.tableAppend (outTable, attackChecksConfig)
    local icsaConfig = db.getRow ("Igmp","_ROWID_","1")
    outTable = util.tableAppend (outTable, icsaConfig)
    --local dosAttacksConfig = db.getRow ("PowerModeConf","_ROWID_","1")
    --outTable = util.tableAppend (outTable, dosAttacksConfig)

    if (outTable == nil) then
        outTable = {}
    end
    return outTable  
end

-- attackChecks6 config
function attackChecks6.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    
    db.beginTransaction() --begin transaction
    local valid = false

    local ipMode = db.getAttribute ("networkInfo", "_ROWID_", "1", "netWorkMode") or ''

    DBTable = "AttackChecks6"
    valid = fw.config(inputTable, rowid, operation)

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "FW_AC_CONFIG_FAILED"
    end
end

-- attackChecks6 configGet
function attackChecks6.configGet ()
    local outTable = {}
    local attackChecks6Config = db.getRow ("AttackChecks6","_ROWID_","1")
    outTable = util.tableAppend (outTable, attackChecks6Config)

    if (outTable == nil) then
        outTable = {}
    end
    return outTable  
end
