--[[
#### Vivek Dutt Sharma.
#### TeamF1
#### www.TeamF1.com
#### Feb 23, 2010
#### File: dhcpOverIpSec.lua
#### Description: DHCP Over Ipsec Ip address functions
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package DHCP over IpSec Address Range configuration
dhcpOverIpsec = {}

--[[
/******************************************************************************
*
* dhcpOverIpsec.config - manipulates data for configuration operations
*  RETURNS: ACCESS_DENIED or OK or ERROR
* 
*
*/
]]--


--************* Functions *************

-- dhcp over ipSec config
function dhcpOverIpsec.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
    	return "ACCESS_DENIED", "10187"
    end
    db.beginTransaction() --begin transaction
    local valid = false
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            valid = db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            valid = db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
	    valid = db.delete(DBTable, inputTable)
        end
    end

    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", "12265"
    else
        db.rollback()
        return "ERROR", "10567"
    end
end
