-- dmzCLI.lua
-- Ravindranath
-- TeamF1
-- www.TeamF1.com
-- Description
-- CLISH dmz LUA routines
-- 13jan12,akr fixed 29174 
-- 29nov11,akr fixed 28094
--
require "teamf1lualib/lan"
require "teamf1lualib/dhcp"
require "teamf1lualib/dhcpv6"

--
--This routine initializes the DMZ configuration
function dmzipv6CfgInit()
    local where = "LogicalIfName = 'DMZ' AND AddressFamily = 10"
	local rowid = db.existsRowWhere ("ifStatic", where)
    configRow = db.getRow("ifStatic", "_ROWID_", rowid)	
    local dhcpConfigRow = db.getRow ("dhcpv6s", "logicalIfName", "DMZ")
    if (dhcpConfigRow ~= nil) then
	    configRow ["dhcpv6s.isEnabled"] = dhcpConfigRow["dhcpv6s.isEnabled"]
		if (configRow ["dhcpv6s.isEnabled"] ~= 0) then			
			configRow ["dhcpv6s.isEnabled"] = dhcpConfigRow ["dhcpv6s.isEnabled"]
			configRow ["dhcpv6s.serverPreference"] = dhcpConfigRow ["dhcpv6s.serverPreference"]
			configRow ["dhcpv6s.startAddress"] = dhcpConfigRow ["dhcpv6s.startAddress"]
			configRow ["dhcpv6s.endAddress"] = dhcpConfigRow ["dhcpv6s.endAddress"]
			configRow ["dhcpv6s.primaryDnsServer"] = dhcpConfigRow ["dhcpv6s.primaryDnsServer"]
			configRow ["dhcpv6s.secondaryDnsServer"] = dhcpConfigRow ["dhcpv6s.secondaryDnsServer"]			
			configRow ["dhcpv6s.leaseTime"] = dhcpConfigRow ["dhcpv6s.leaseTime"]
		end
	end
	
    local dhcpEnable = db.getRow("ConfigPort","_ROWID_","2")
    configRow ["ConfigPort.LogicalIfName"] = dhcpEnable ["ConfigPort.LogicalIfName"]
--[[
    local dhcpLdapConfig = db.getRow("DhcpLdapServerInfo","LogicalIfName","DMZ")
    if (dhcpLdapConfig ~= nil) then
        if (configRow ["dhcpv6s.isEnabled"] ~= 0) then
            configRow ["DhcpLdapServerInfo.DhcpLdapStatus"] = dhcpLdapConfig ["DhcpLdapServerInfo.DhcpLdapStatus"]
            if (dhcpLdapConfig["DhcpLdapServerInfo.DhcpLdapStatus"] == "1") then
                configRow ["DhcpLdapServerInfo.DhcpLdapServerIP"] = dhcpLdapConfig ["DhcpLdapServerInfo.DhcpLdapServerIP"]
                configRow ["DhcpLdapServerInfo.DhcpLdapSearchBase"] = dhcpLdapConfig ["DhcpLdapServerInfo.DhcpLdapSearchBase"]
                configRow ["DhcpLdapServerInfo.DhcpLdapServerPort"] = dhcpLdapConfig ["DhcpLdapServerInfo.DhcpLdapServerPort"]
            end
        end
    end
    ]]
	return -1,configRow

end

--
--This routine validates the DMZ configuration
function dmzipv6CfgInputVal(configRow)
 
    local ipMode = db.getAttribute ("networkInfo", "_ROWID_", "1", "netWorkMode") or ''
    if (ipMode == "1") then
        printCLIError ("Please Set IP Mode to IPv4/IPv6 to configure DMZ in IPv6 Mode.\n")
	return false
    end

    if (configRow ["ConfigPort.LogicalIfName"] == "" or
        configRow ["ConfigPort.LogicalIfName"] == nil )then
	    printCLIError("Invalid DMZ status")
        return false
    end
    if(configRow ["ConfigPort.LogicalIfName"] == "DMZ") then
--[[        if (configRow["dhcpv6s.isEnabled"] == "" or
            configRow["dhcpv6s.isEnabled"] == nil) then
            printCLIError("Invalid dhcp status")
        return false
        end
]]
        if (configRow["ifStatic.StaticIp"] == "" or
            configRow["ifStatic.StaticIp"] == nil or
            configRow["ifStatic.StaticIp"] == "0.0.0.0") then
            printCLIError("Invalid DMZ IP address")
            return false
        end
	if(configRow["ifStatic.PrefixLength"] == nil or configRow["ifStatic.PrefixLength"] =="") then
		printCLIError("Please Enter prefix_length !!")
		return false
	elseif(tonumber(configRow["ifStatic.PrefixLength"]) < 1 or tonumber(configRow["ifStatic.PrefixLength"]) > 128) then
		printCLIError("Please enter prefix length between 1 to 128 !!")
		return false
	end
        if (configRow["dhcpv6s.isEnabled"] == "" or
            configRow["dhcpv6s.isEnabled"] == nil) then
            printCLIError("Please select dhcp_enable !! ")
	    return false
        end
        if (configRow["dhcpv6s.isEnabled"] == "1") then 
		if(configRow["dhcpv6s.useDNSServersFrom"] == "nil" or configRow["dhcpv6s.useDNSServersFrom"] == "" ) then
			printCLIError("Please Enter DNS Preference !!")
			return false
		elseif(configRow["dhcpv6s.useDNSServersFrom"] == "3") then
			if( ( configRow["dhcpv6s.primaryDNSServer"] == nil or configRow["dhcpv6s.primaryDNSServer"] == "") and (configRow["dhcpv6s.secondaryDNSServer"] == nil or configRow["dhcpv6s.secondaryDNSServer"] == "")) then
				printCLIError("Please Select Primary/Secondary DNS Server !!")
				return false
			end
		end
		if (configRow["dhcpv6s.serverPreference"] == "" or configRow["dhcpv6s.serverPreference"] == nil) then
			printCLIError("Please enter server Preference !!")
			return false
		elseif (tonumber(configRow["dhcpv6s.serverPreference"]) < 0  or tonumber(configRow["dhcpv6s.serverPreference"]) > 255) then
			printCLIError("Please enter serverPreference between 0 to 255 !!")
			return false
		end
		if (configRow["dhcpv6s.leaseTime"] == "" or configRow["dhcpv6s.leaseTime"] == nil) then
			printCLIError("Please enter Lease Time !!")
			return false
		elseif (tonumber(configRow["dhcpv6s.leaseTime"]) < 0 or tonumber(configRow["dhcpv6s.leaseTime"]) > 604800 ) then
			printCLIError("Please enter lease time between 0 to 604800 !!")
			return false
		end
	end
--[[
        if (configRow["dhcpv6s.isEnabled"] == "1" and 
            (configRow["DhcpLdapServerInfo.DhcpLdapStatus"] == "" or
            configRow["DhcpLdapServerInfo.DhcpLdapStatus"] == nil)) then
            printCLIError ("Invalid Ldap status")
            return false
        end

        if (configRow["dhcpv6s.isEnabled"] == "1" and
            configRow["DhcpLdapServerInfo.DhcpLdapStatus"] == "1" and
            (configRow["DhcpLdapServerInfo.DhcpLdapServerIP"] == nil or
            configRow["DhcpLdapServerInfo.DhcpLdapServerIP"] == "")) then 
            printCLIError ("Invalid Ldap server IP")
            return false
        end
        if (configRow["dhcpv6s.isEnabled"] == "1" and
            configRow["DhcpLdapServerInfo.DhcpLdapStatus"] == "1" and
            (configRow ["DhcpLdapServerInfo.DhcpLdapSearchBase"] == nil or
            configRow ["DhcpLdapServerInfo.DhcpLdapSearchBase"] == "" )) then
            printCLIError ("Invalid Ldap search base")
            return false
        end
        if (configRow["dhcpv6s.isEnabled"] == "1" and
            configRow["DhcpLdapServerInfo.DhcpLdapStatus"] == "1" and
            (configRow ["DhcpLdapServerInfo.DhcpLdapServerPort"] == nil or
            configRow ["DhcpLdapServerInfo.DhcpLdapServerPort"] > "65535" or
            configRow ["DhcpLdapServerInfo.DhcpLdapServerPort"] < "0" or
            configRow ["DhcpLdapServerInfo.DhcpLdapServerPort"] == "")) then
            printCLIError ("Invalid Ldap port")
            return false
        end
	]]
    else
	    if (db.getAttribute("ConfigPort","rowid","2","LogicalIfName") ~="DMZ") then
		    printCLIError("DMZ is Disabled .. First enable DMZ!!")
		    return false
	    end
    end
    return true
end

--
-- 
function dmzipv6PoolInit (args)
    local dhcpv6sDMZAddrPoolRow = db.getRow("dhcpv6sDMZAddrPool","startAddress",args[1])
    if (dhcpv6sDMZAddrPoolRow == nil) then
        dhcpv6sDMZAddrPoolRow = {}
	rowid="-1" --add case
	dhcpv6sDMZAddrPoolRow ["dhcpv6sDMZAddrPool._ROWID_"] = "-1"
	dhcpv6sDMZAddrPoolRow["dhcpv6sDMZAddrPool.startAddress"] = args[1]
    else
        rowId = dhcpv6sDMZAddrPoolRow["dhcpv6sDMZAddrPool._ROWID_"]
	dhcpv6sDMZAddrPoolRow["dhcpv6sDMZAddrPool.startAddress"] = args[1]
    end
    return rowId, dhcpv6sDMZAddrPoolRow	
end

--
-- This routine saves the modified dhcpv6sDMZAddrPoolRow information.
function dmzipv6PoolSave (configRow)
    local errorFlag = nil
    local statusCode = ""
    local statusMessage = nil
    DBTable = "dhcpv6sDMZAddrPool"
    if (configRow ["dhcpv6sDMZAddrPool._ROWID_"] == "-1") then
        errorFlag, statusCode = lan.poolConfig(configRow, "-1", "add")
    else
        errorFlag, statusCode = lan.poolConfig(configRow, configRow ["dhcpv6sDMZAddrPool._ROWID_"], "edit")
    end

    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
   
    return errorFlag, statusMessage
end
function dmzipv6PoolVal(configRow)
    local ipmode = db.getRow("networkInfo", "_ROWID_", "1")
    if(ipmode["networkInfo.netWorkMode"] == "1")then
    printCLIError("Please Set IP Mode to IPv4/IPv6 to configure IPv6 LAN Configurations.")
    return false
    end
    if (configRow ["dhcpv6sDMZAddrPool.startAddress"] == "" or configRow ["dhcpv6sDMZAddrPool.startAddress"] == nil) then
         printCLIError("Please Enter valid IPv6 Start Address.")
         return false

    end
    if (configRow ["dhcpv6sDMZAddrPool.endAddress"] == "" or configRow ["dhcpv6sDMZAddrPool.endAddress"] == nil) then
         printCLIError("Please Enter valid IPv6 End Address.")
         return false
    end

    if (configRow["dhcpv6sDMZAddrPool.prefixLength"] == nil or configRow["dhcpv6sDMZAddrPool.prefixLength"] == "" )then
	 printCLIError("Please Select Prefix Length !!")
	 return false
    elseif((tonumber(configRow["dhcpv6sDMZAddrPool.prefixLength"]) < 0) or (tonumber(configRow["dhcpv6sDMZAddrPool.prefixLength"]) > 128 )) then
        printCLIError ("Invalid Prefix. Please enter a value between 0 and 128.")
        return false
    end
    return true
end

--
-- This routine delete the modified dhcpv6sDMZAddrPool configuration information.
function DMZIPv6PoolDel (startAddress)
    local errorFlag = nil
    local statusCode = ""
    local statusMessage = nil
    DBTable = "dhcpv6sDMZAddrPool"
    local startAddr = startAddress[1]
    local rowId = -1
    local dhcpv6sDMZAddrPoolRow = db.getRow("dhcpv6sDMZAddrPool","startAddress", startAddr)
    if (dhcpv6sDMZAddrPoolRow == nil) then
        printCLIError ("Address doesn't match with any of the configuration")
        return false
    else
        rowId = dhcpv6sDMZAddrPoolRow["dhcpv6sDMZAddrPool._ROWID_"]
    end
    row = {}
    row["_ROWID_"] = dhcpv6sDMZAddrPoolRow ["dhcpv6sDMZAddrPool._ROWID_"]
    errorFlag, statusCode = lan.lanPoolsDelete(dhcpv6sDMZAddrPoolRow)

    -- save db if no error
    if (errorFlag == "OK") then 
        db.save() 
        print ("Row deleted")
    end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
   
    return errorFlag, statusMessage
end
  
--
--This routine saves the DMZ configuration
function dmzipv6CfgSave(configRow)
	local errorFlag="OK"
	local statusCode=""
	local statusMessage=""
    
    if (configRow ["ConfigPort.LogicalIfName"] == "DMZ") then
        --DMZ is enabled.
        db.setAttribute("dmzLED","_ROWID_","2","ledStatus","1")
    else
        --DMZ is disabled.
      	if(configRow["ConfigPort.LogicalIfName"] == "LAN") then
	        configRow["dhcpv6s.isEnabled"] = "0"
	end

        db.setAttribute("dmzLED","_ROWID_","2","ledStatus","0")
    end

	local where = "LogicalIfName = 'DMZ' AND AddressFamily = 10"
	local rowid = db.existsRowWhere ("ifStatic", where)
	
    errorFlag, statusCode = lan.ipv6LanConfig(configRow, rowid, "edit")
    	
    if (errorFlag == "OK") then
	    db.save()
		errorFlag, statusCode = dhcpv6.dhcpConfigWrap (configRow, "DMZ")
    end

	-- save db if no error
	if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage

end

--
--This routine gets the DMZ configuration
function dmzipv6SetupGet()
    local resultTab = {} -- table to store DMZ setup information
    local where = "LogicalIfName = 'DMZ' AND AddressFamily = 10"
    local rowid = db.existsRowWhere ("ifStatic", where)
    local ipv6LanRow = db.getRow("ifStatic", "_ROWID_", rowid )
--    local LdapRow = db.getRow("DhcpLdapServerInfo","LogicalIfName","DMZ")

    local ipMode = db.getAttribute ("networkInfo", "_ROWID_", "1", "netWorkMode") or ''
    if (ipMode == "1") then
        printCLIError ("Please Set IP Mode to IPv4/IPv6. \n")
	return false
    end

    printLabel ("DMZ Setup")

    local DMZRow = db.getRow("ConfigPort","_ROWID_","2")
    
    if ( DMZRow["ConfigPort.LogicalIfName"] == "DMZ") then
    
        if(ipv6LanRow ~= nil) then
            resTab.insertField (resultTab, "IPv6 Address", ipv6LanRow["ifStatic.StaticIp"] or "")
            resTab.insertField (resultTab, "Prefix Length", ipv6LanRow["ifStatic.PrefixLength"]or "")   
        end

        printLabel ("DHCP Setup Configuration")    
        local whereDhcp = "LogicalIfName = 'DMZ'"
        local rowidDhcp = db.existsRowWhere ("dhcpv6s", whereDhcp)
        dhcpTable = db.getRow ("dhcpv6s","_ROWID_", rowidDhcp)
--        local addPoolTable = db.getRow ("dhcpv6sDMZAddrPool","_ROWID_", "1")

    
        if (dhcpTable ~= nil) then 
            
            if (dhcpTable ["dhcpv6s.isEnabled"] == "0") then
                resTab.insertField (resultTab, "DHCP Status", "DHCP Server Disabled")
            end
            if (dhcpTable ["dhcpv6s.isEnabled"] == "1") then
                resTab.insertField (resultTab, "DHCP Status", "DHCP Server Enabled")
		if(dhcpTable["dhcpv6s.statelessMode"] == "1") then
	                resTab.insertField (resultTab, "Mode","Stateless")
		elseif(dhcpTable["dhcpv6s.statelessMode"] == "0") then
	                resTab.insertField (resultTab, "Mode","Stateful")
		end
                resTab.insertField (resultTab, "Domain Name", dhcpTable["dhcpv6s.domainName"] or "")
		if ( dhcpTable["dhcpv6s.useDNSServersFrom"] == "3") then
			resTab.insertField (resultTab, "Primary DNS Server", dhcpTable["dhcpv6s.primaryDNSServer"] or "")
         		resTab.insertField (resultTab, "Secondary DNS Server",dhcpTable["dhcpv6s.secondaryDNSServer"] or "")
		elseif ( dhcpTable["dhcpv6s.useDNSServersFrom"] == "2") then
			resTab.insertField (resultTab, "DNS Server", "Use DNS from ISP")
		elseif ( dhcpTable["dhcpv6s.useDNSServersFrom"] == "1") then
			resTab.insertField (resultTab, "DNS Server", "Use DNS Proxy")
		end
                resTab.insertField (resultTab, "Lease Time in Sec ",dhcpTable["dhcpv6s.leaseTime"] or "")
                local addPoolTable = db.getTable ("dhcpv6sDMZAddrPool")
		local s = " "
		local e = " "
		local p = " "
		if ( addPoolTable ~= nil) then
			for i = 1,#addPoolTable do 
				local v = db.getRow("dhcpv6sDMZAddrPool","_ROWID_",tostring(i))
				s = s .. v["dhcpv6sDMZAddrPool.startAddress"] .. " "
				e = e .. v["dhcpv6sDMZAddrPool.endAddress"] .. " "
				p = p .. v["dhcpv6sDMZAddrPool.prefixLength"] .. " "

			end
		end
	        resTab.insertField (resultTab, "Starting IP Address ", s or "")
		resTab.insertField (resultTab, "Ending IP Address   ", e or "")
		resTab.insertField (resultTab, "Pool Prefix Length  ", p or "")
		--[[
	            if (LdapRow["DhcpLdapServerInfo.DhcpLdapStatus"] == "1") then
		            resTab.insertField (resultTab,"LDAP Status", "Enabled")
		            resTab.insertField (resultTab,"DhcpLdapServerIP",LdapRow["DhcpLdapServerInfo.DhcpLdapServerIP"])
		            resTab.insertField (resultTab,"DhcpLdapSearchBase",LdapRow["DhcpLdapServerInfo.DhcpLdapSearchBase"])
		            resTab.insertField (resultTab,"DhcpLdapServerPort",LdapRow["DhcpLdapServerInfo.DhcpLdapServerPort"])
                end
		]]
            end
        end               
        resTab.print (resultTab, 0)
    else
	    printCLIError("DMZ Disabled.")
    end

	return true
end
