--[[
#### 
#### File: ifDevTrExtn.lua
#### Description: 
#### TR-98 handlers for ifDev. This file is included from
#### tr69Glue code.
####

#### Revisions:
01a,14jul10,sam  written
]]--

ifDevTr = {}

--[[
--*****************************************************************************
-- ifDevTr.ifStatsGet - get interface statistics 
-- 
-- This function gets interface statistics.
--
-- RETURN: number of instances
]]--

function ifDevTr.ifStatsGet(input)
    local param = input["param"]
	local row = {}
	local status = "0"
    local value = " "
	local rowId
	local status 

	-- retrieve statistics
    local instanceMap =  tr69Glue.instanceMapLoad()
    if (instanceMap == nil) then
		return status, value
    end

    rowId = instanceMap [param]
    if (rowId == nil) then
		return status, value
    end
	
	local query = "_ROWID_=" .. rowId
	row = db.getRowWhere ("interfaceStats", query, false)
	if (row == nil) then
    	return "1" ,"DB_ERROR_TRY_AGAIN"
	end

	if (input["field"] == "tx_bytes") then
		value = row["tx_bytes"]
	elseif (input["field"] == "rx_bytes") then
		value = row["rx_bytes"]
	elseif (input["field"] == "rx_packets") then
		value = row["rx_packets"]
	elseif (input["field"] == "tx_packets") then
		value = row["tx_packets"]
	end

	
	return status, value
end

