--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### May 16, 2008
#### File: protocolBinding.lua
#### Description: protocolBinding functions
#### Revisions:
01a,22May12, sig, fixed for spr 31790
]]--

--************* Requires *************

--************* Initial Code *************

--package Firewall Rules Configurations
protocolBinding = {}

--************* Functions *************
-- Protocol Binding Config
function protocolBinding.config (inputTable, rowid, operation)
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transactions
    local valid = false
    local test =  db.getTable("ProtocolBinding")
    local rowId = 0
    for k,v in pairs(test) do
        rowId = rowId+1
        local testrow = test [rowId]
        if(rowid ~= testrow["ProtocolBinding._ROWID_"]) then
            if(inputTable["ProtocolBinding.ServiceName"]== testrow["ProtocolBinding.ServiceName"]and
                inputTable["ProtocolBinding.LocalGateway"]== testrow["ProtocolBinding.LocalGateway"]) then
                if(inputTable["ProtocolBinding.SourceNetworkType"] == "0" and 
                    inputTable["ProtocolBinding.DestinationNetworkType"] == "0" ) then
                    if(testrow["ProtocolBinding.SourceNetworkType"] == "0" and
                        testrow["ProtocolBinding.DestinationNetworkType"] == "0" ) then
                        return "ERROR","PB_RULE_ALREADY_EXIST"
                    end
                elseif ( inputTable["ProtocolBinding.SourceNetworkType"] == "1" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "1") then
                    if(testrow["ProtocolBinding.DestinationNetworkType"]== "1" and 
                        testrow["ProtocolBinding.SourceNetworkType"] == "1") then 
                        if(inputTable["ProtocolBinding.SourceNetworkStart"] == 
                            testrow["ProtocolBinding.SourceNetworkStart"] and
                            inputTable["ProtocolBinding.DestinationNetworkStart"] ==
                            testrow["ProtocolBinding.DestinationNetworkStart"]) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "2" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "2") then
                    if(testrow["ProtocolBinding.SourceNetworkType"] == "2" and 
                        testrow["ProtocolBinding.DestinationNetworkType"] == "2") then
                        if(inputTable["ProtocolBinding.SourceNetworkStart"] == 
                            testrow["ProtocolBinding.SourceNetworkStart"] and 
                            inputTable["ProtocolBinding.DestinationNetworkStart"] ==
                            testrow["ProtocolBinding.DestinationNetworkStart"] and
                            inputTable["ProtocolBinding.SourceNetworkEnd"] == 
                            testrow["ProtocolBinding.SourceNetworkEnd"] and  
                            inputTable["ProtocolBinding.DestinationNetworkEnd"]==
                            testrow["ProtocolBinding.DestinationNetworkEnd"]) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                    elseif (inputTable["ProtocolBinding.SourceNetworkType"] >= "3") then
                    if (inputTable["ProtocolBinding.SourceNetworkType"]== 
                        testrow["ProtocolBinding.SourceNetworkType"] ) then
                        if ((inputTable["ProtocolBinding.DestinationNetworkType"] =="0"
                            and testrow["ProtocolBinding.DestinationNetworkType"]== "0") ) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        elseif ((inputTable["ProtocolBinding.DestinationNetworkType"]== "1" and 
                            testrow["ProtocolBinding.DestinationNetworkType"] == "1")) then
                            if(inputTable["ProtocolBinding.DestinationNetworkStart"] == 
                                testrow["ProtocolBinding.DestinationNetworkStart"]) then
                                return "ERROR","PB_RULE_ALREADY_EXIST"
                            end
                        elseif((inputTable["ProtocolBinding.DestinationNetworkType"] == "2" and 
                            testrow["ProtocolBinding.DestinationNetworkType"] == "2" )) then
                            if(inputTable["ProtocolBinding.DestinationNetworkStart"]==
                                testrow["ProtocolBinding.DestinationNetworkStart"] and 
                                inputTable["ProtocolBinding.DestinationNetworkEnd"] == 
                                testrow["ProtocolBinding.DestinationNetworkEnd"]) then
                                return "ERROR","PB_RULE_ALREADY_EXIST"
                            end
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "0" and
                    inputTable["ProtocolBinding.DestinationNetworkType"] == "1") then
                    if (testrow["ProtocolBinding.SourceNetworkType"] == "0" and
                        testrow["ProtocolBinding.DestinationNetworkType"] == "1") then
                        if (inputTable["ProtocolBinding.DestinationNetworkStart"]==
                            testrow["ProtocolBinding.DestinationNetworkStart"]) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "0" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "2") then
                    if (testrow["ProtocolBinding.SourceNetworkType"] == "0" and 
                        testrow["ProtocolBinding.DestinationNetworkType"] == "2") then
                        if(inputTable["ProtocolBinding.DestinationNetworkStart"]== 
                            testrow["ProtocolBinding.DestinationNetworkStart"] and 
                            inputTable["ProtocolBinding.DestinationNetworkEnd"] == 
                            testrow["ProtocolBinding.DestinationNetworkEnd"]) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "1" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "0") then
                    if (testrow["ProtocolBinding.SourceNetworkType"] == "1" and 
                        testrow["ProtocolBinding.DestinationNetworkType"] == "0") then
                        if(inputTable["ProtocolBinding.SourceNetworkStart"]== 
                            testrow["ProtocolBinding.SourceNetworkStart"]) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "1" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "2") then
                    if (testrow["ProtocolBinding.SourceNetworkType"] == "1" and 
                        testrow["ProtocolBinding.DestinationNetworkType"] == "2") then
                        if(inputTable["ProtocolBinding.SourceNetworkStart"] == 
                            testrow["ProtocolBinding.SourceNetworkStart"] and 
                            inputTable["ProtocolBinding.DestinationNetworkStart"]== 
                            testrow["ProtocolBinding.DestinationNetworkStart"] and 
                            inputTable["ProtocolBinding.DestinationNetworkEnd"] == 
                            testrow["ProtocolBinding.DestinationNetworkEnd"]) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "2" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "0") then
                    if (testrow["ProtocolBinding.SourceNetworkType"] == "2" and 
                        testrow["ProtocolBinding.DestinationNetworkType"] == "0") then
                        if(inputTable["ProtocolBinding.SourceNetworkStart"] == 
                            testrow["ProtocolBinding.SourceNetworkStart"] and 
                            inputTable["ProtocolBinding.SourceNetworkEnd"] == 
                            testrow["ProtocolBinding.SourceNetworkEnd"] ) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                elseif (inputTable["ProtocolBinding.SourceNetworkType"] == "2" and
                    inputTable["ProtocolBinding.DestinationNetworkType"]== "1") then
                    if (testrow["ProtocolBinding.SourceNetworkType"] == "2" and 
                        testrow["ProtocolBinding.DestinationNetworkType"] == "1") then
                        if(inputTable["ProtocolBinding.SourceNetworkStart"] == 
                            testrow["ProtocolBinding.SourceNetworkStart"] and
                            inputTable["ProtocolBinding.SourceNetworkEnd"] == 
                            testrow["ProtocolBinding.SourceNetworkEnd"] and 
                            inputTable["ProtocolBinding.DestinationNetworkStart"] == 
                            testrow["ProtocolBinding.DestinationNetworkStart"] ) then
                            return "ERROR","PB_RULE_ALREADY_EXIST"
                        end
                    end
                end
            end
        end
    end

    if (db.typeAndRangeValidate(inputTable)) then
      	if (operation == "add") then
        	valid = db.insert("ProtocolBinding", inputTable)
       	elseif (operation == "edit") then
        	valid = db.update("ProtocolBinding", inputTable, rowid)
       	elseif (operation == "delete") then
        	valid = false
       	end
    end

    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "PB_RULE_CONFIG_FAILED"
    end
end

-- Modify Protcol Binding Rules (Enable/Disable/Delete)
function protocolBinding.modifyRules (rowIds, operation)
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transactions
    local valid = true
    local errStr = "STATUS_OK"

    if (operation == "enable") then
        for k,v in pairs(rowIds) do
            local inTable = {}
            inTable["ProtocolBinding.Enabled"] = "1";
            valid = db.update("ProtocolBinding", inTable, v)
            if (valid == false) then
                errStr = "PB_RULES_ENABLED_FAILED"
                break
            end
        end

        if (valid) then
            errStr = "PB_RULES_ENABLED"       
        end
    elseif (operation == "disable") then
        for k,v in pairs(rowIds) do
            local inTable = {}
            inTable["ProtocolBinding.Enabled"] = "0";
            valid = db.update("ProtocolBinding", inTable, v)
            if (valid == false) then
                errStr = "PB_RULES_DISABLED_FAILED"
                break
            end
        end
        if (valid) then
            errStr = "PB_RULES_DISABLED"
        end
    else
        for k,v in pairs(rowIds) do
            local inTable = {}
            inTable["ProtocolBinding._ROWID_"] = v;
            valid = db.delete("ProtocolBinding", inTable)
            if (valid == false) then
                errStr = "PB_RULES_DELETE_FAILED"
                break
            end
        end
        if (valid) then
            errStr = "PB_RULES_DELETED"
        end
    end

    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", errStr
    else
        db.rollback()
        return "ERROR", errStr
    end
end
