--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: userdb.lua
#### Description: userdb functions

#### Revisions:
01a, 27dec10, bhj, Fixed SPR 20720
]]--


--************* Requires *************

--************* Initial Code *************

--package userdb
userdb = {}

--table packages
users = {}

--************* Functions *************
-- users config
function users.config (inputTable, rowid, operation)
    -- validate
    if (users.inputvalidate(inputTable, operation)) then
        if (operation == "add") then
            return db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            return db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete(DBTable, inputTable)
        end
    end
    return false
end

-- users inputvalidate
function users.inputvalidate (inputTable, operation)
    if (true) then
        local valid = db.typeAndRangeValidate(inputTable)
        return valid
    end
    return false
end

--[[
******************************************************************** 
* users.add -  used to add users to the table
* 
* RETURNS: true or false 
*
]]--

function users.add (inputTable)

    -- table to collect user information and add to database

    local addUserTable = {}

    -- variable declaration

    local valid = false
    local operation = "add"

     -- if not allowed to add
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    db.beginTransaction() --begin transaction

    if(inputTable ~= nil) then

        if(inputTable["USERDBUsers.UserName"]~= nil) then
            addUserTable["USERDBUsers.UserName"] = inputTable["USERDBUsers.UserName"]
        end

        if(inputTable["USERDBUsers.FirstName"]~= nil) then
            addUserTable["USERDBUsers.FirstName"] = inputTable["USERDBUsers.FirstName"]
        end

        if(inputTable["USERDBUsers.LastName"]~= nil) then
            addUserTable["USERDBUsers.LastName"] = inputTable["USERDBUsers.LastName"]
        end

        if(inputTable["USERDBUsers.UserType"]~= nil) then
            addUserTable["USERDBUsers.UserType"] = inputTable["USERDBUsers.UserType"]
            -- if user type is 3 then it is admin user and we need to add GroupName for 
            -- it as 'admin'
            if(addUserTable["USERDBUsers.UserType"] == "3") then
                addUserTable["USERDBUsers.GroupName"] = "admin"
            else
                addUserTable["USERDBUsers.GroupName"] = "guest"
            end
        end

        if(inputTable["USERDBUsers.UserTimeOut"]~= nil) then
                addUserTable["USERDBUsers.UserTimeOut"] = inputTable["USERDBUsers.UserTimeOut"]
        end

        -- GroupId is a dummy value

        if(inputTable["USERDBUsers.groupid"]~= nil) then
                addUserTable["USERDBUsers.groupid"] = 0
        end

        -- AllowChangePassword is a dummy value
        
        if(inputTable["USERDBUsers.AllowChangePassword"]~= nil) then
                addUserTable["USERDBUsers.AllowChangePassword"] = 0
        end

        
        if(inputTable["USERDBUsers.Password"]~= nil) then
                addUserTable["USERDBUsers.Password"] = inputTable["USERDBUsers.Password"]
        end

        -- Adding users data to userdbuser table

        valid = users.config (addUserTable, "", operation)   
    end
    if (valid) then
        db.commitTransaction(true)
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "USERDB_CONFIG_FAILED"
    end
    
end

function users.edit (inputTable, rowid)
    -- variable declaration

    local valid = false
    local operation = "edit"

     -- if not allowed to add
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    db.beginTransaction() --begin transaction
    
    -- If User type is changed from admin to other type then make groupName 'guest'
    
    -- Getting the row to edit from the table
    --
    local userRow = db.getRow('USERDBUsers', "_ROWID_", rowid)

    -- check for all the incoming parameters and replace in the userRow if not nil
    --   
    
    if(inputTable["USERDBUsers.UserName"] ~= nil) then
        userRow["USERDBUsers.UserName"] = inputTable["USERDBUsers.UserName"]
    end

    if(inputTable["USERDBUsers.FirstName"] ~= nil) then
        userRow["USERDBUsers.FirstName"] = inputTable["USERDBUsers.FirstName"]
    end

    if(inputTable["USERDBUsers.LastName"] ~= nil) then
        userRow["USERDBUsers.LastName"] = inputTable["USERDBUsers.LastName"]
    end

    if(inputTable["USERDBUsers.UserType"] ~= nil) then
	if(inputTable["USERDBUsers.UserType"] == "3") then
		userRow["USERDBUsers.GroupName"] = "admin"
	else
		userRow["USERDBUsers.GroupName"] = "guest"
	end
    --If usertype is runtime
    if(userRow["USERDBUsers.UserType"] == "10") then
       local rtrowid = db.getAttribute("CaptivePortalSession", "UserName", userRow["USERDBUsers.UserName"]  ,"_ROWID_")
            if (rtrowid ~= nil) then 
                if(inputTable["USERDBUsers.UserType"] == "10") then
                   local rtRow =  db.getRow("CaptivePortalSession", "_ROWID_", rtrowid)
                   rtRow["CaptivePortalSession.idleTimeout"] = inputTable["USERDBUsers.UserTimeOut"]
                   db.update ("CaptivePortalSession", rtRow, rtrowid)
                else
                   local temptable = {}
                   temptable["CaptivePortalSession._ROWID_"] = rtrowid
                   db.delete ("CaptivePortalSession",temptable) 
                end            
            end
    end    
        userRow["USERDBUsers.UserType"] = inputTable["USERDBUsers.UserType"]
    end

    if(inputTable["USERDBUsers.Password"] ~= nil) then
        userRow["USERDBUsers.Password"] = inputTable["USERDBUsers.Password"]
    end

    if(inputTable["USERDBUsers.UserTimeOut"] ~= nil) then
        userRow["USERDBUsers.UserTimeOut"] = inputTable["USERDBUsers.UserTimeOut"]
    end


    --Checking the users own password to change any users password.

    if(inputTable ~= nil) then
        if (inputTable["USERDBUsers.PasswordEdit"] == "1" and inputTable["USERDBUsers.MyPassword"] ~= nil) then
            local wherePart = "ipaddr = '" .. SAPI.Request.servervariable("REMOTE_ADDR") .. "' AND Cookie = '" .. cgilua.cookies.get("TeamF1Login") .. "'"
            local row = db.getRowWhere("loginSession", wherePart)
            if (row ~= nil) then
                    local userPwd = db.getAttribute ("USERDBUsers", "UserName", row["loginSession.username"], "Password")
                    if (userPwd ~= inputTable["USERDBUsers.MyPassword"]) then
                        db.rollback()
                        return "ERROR", "WRONG_USER_PASSWORD"
                    end
            else
                    db.rollback()
                    return "ERROR", "USER_SESSION_NOT_FOUND"
            end
        end
    valid = users.config (userRow, rowid, operation)
    end

    -- If valid commit transaction else rollback

    if (valid) then
            db.commitTransaction(true)
            return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "USERDB_CONFIG_FAILED"
    end

end

--[[
******************************************************************** 
* users.delete -  used to add users to the table
* 
* RETURNS: true or false 
*
 --]]
function users.delete(rows)
    local valid = false
    local operation = "delete"
	local status = nil
    -- if not allowed to delete
    if (ACCESS_LEVEL ~= 0) then
         return "ACCESS_DENIED", "ADMIN_REQD"
    end
    db.beginTransaction() --begin transaction
    if(rows ~= nil) then
       for k,v in pairs (rows) do
        -- if the row is of runtimeauthentication then delete in
        -- captiveportalSession also
        local userType = db.getAttribute (DBTable, "_ROWID_", v, "UserType")
        if (userType == "10") then
            local userName = db.getAttribute(DBTable, "_ROWID_", v, "UserName")
            local rtrowid  = db.getAttribute("CaptivePortalSession", "UserName", userName,"_ROWID_")
            if (rtrowid ~= nil) then
                local temptable = {}
                temptable["CaptivePortalSession._ROWID_"] = rtrowid
                db.delete ("CaptivePortalSession", temptable)
            end    
        end

        local table = {}
        table["USERDBUsers._ROWID_"] = v
		if (db.existsRow("loginSession", "username", userName) == false) then
        	valid = db.delete (DBTable, table)
		else
			status = "DELETE_FAILED_USER_LOGGEDIN"
            valid = false
		end
        if(not valid) then break end
    end
    end
    if (valid) then
            db.commitTransaction(true)
            return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", status or "USERDB_CONFIG_FAILED"
    end    
end

--[[
******************************************************************** 
* users.delete -  used to add users to the table
* 
* RETURNS: true or false 
*
 --]]
function users.numberOfUsers(maxUsers)    
    local userTable = db.getTable("USERDBUsers")
    local noOfUsers = tonumber(#userTable)
    if(noOfUsers >= maxUsers) then
        return "ERROR", "USER_NUMBER_EXCEEDED"
    end
    return "OK", "STATUS_OK"
end

