/* ddns.js - API library for ddns */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b, 19Aug11, Smita P, Modified functions to accomodate 4 WANs
01a,29SEP10,vds  written. 
*/

function wanDdnsStatusCheck (indexValue)
    {
    if (indexValue == 1)
        {
        depFieldCheck ('rdbWan1Yes', true, '', '', '', 'tblWan1DdnsInfo');
        depFieldCheck ('rdbWan1Yes', false, '', 'tblWan1DdnsInfo', '', '');
        if (document.getElementById('rdbWan1Yes').disabled)
            fieldStateChangeWr ('', 'tblWan1DdnsInfo', '', '');
        }
    if (indexValue == 2)
        {
        depFieldCheck ('rdbWan2Yes', true, '', '', '', 'tblWan2DdnsInfo');
        depFieldCheck ('rdbWan2Yes', false, '', 'tblWan2DdnsInfo', '', '');
        if (document.getElementById('rdbWan2Yes').disabled)
            fieldStateChangeWr ('', 'tblWan2DdnsInfo', '', '');
        }
    if (indexValue == 3)
        {
        depFieldCheck ('rdbWan3Yes', true, '', '', '', 'tblWan3DdnsInfo');
        depFieldCheck ('rdbWan3Yes', false, '', 'tblWan3DdnsInfo', '', '');
        if (document.getElementById('rdbWan3Yes').disabled)
            fieldStateChangeWr ('', 'tblWan3DdnsInfo', '', '');
        }
    if (indexValue == 4)
        {
        depFieldCheck ('rdbWan4Yes', true, '', '', '', 'tblWan4DdnsInfo');
        depFieldCheck ('rdbWan4Yes', false, '', 'tblWan4DdnsInfo', '', '');
        if (document.getElementById('rdbWan4Yes').disabled)
            fieldStateChangeWr ('', 'tblWan4DdnsInfo', '', '');
        }
    }
    
function ddnsInit ()
    {    
    var primWanVal = document.getElementById ('hdPrimaryWan').value;
    var wanModeVal = document.getElementById ('hdWanMode').value;
    var noOfWansVal = document.getElementById ('hdNoOfWans').value;
    if (wanModeVal != "Load Balancing")
        {
        if (primWanVal == "WAN1")
            fieldStateChangeWr ('','tblWan2Ddns tblWan3Ddns tblWan4Ddns','','tblWan1Ddns');
        else if (primWanVal == "WAN2")
            fieldStateChangeWr ('','tblWan1Ddns tblWan3Ddns tblWan4Ddns','','tblWan2Ddns');
        else if (primWanVal == "WAN3")
            fieldStateChangeWr ('','tblWan1Ddns tblWan2Ddns tblWan4Ddns','','tblWan3Ddns');
        else if (primWanVal == "WAN4")
            fieldStateChangeWr ('','tblWan1Ddns tblWan2Ddns tblWan3Ddns','','tblWan4Ddns');
        }
    for (i = 1; i <= noOfWansVal; i++)
        wanDdnsStatusCheck (i);
    }
    
function ddnsValidate ()
    {
    var errMsgL10n1 = 'Please specify a valid host and domain name for the Dynamic DNS service on WAN1';    
    var errMsgL10n2 = 'Please specify a valid user/account name for the Dynamic DNS service on WAN1';    
    var errMsgL10n3 = 'Please specify a valid password for the Dynamic DNS service on WAN1';    
    var errMsgL10n4 = 'Please specify a valid host and domain name for the Dynamic DNS service on WAN2';    
    var errMsgL10n5 = 'Please specify a valid user/account name for the Dynamic DNS service on WAN2';
    var errMsgL10n6 = 'Please specify a valid password for the Dynamic DNS service on WAN2';    
    var errMsgL10n7 = 'Please specify a valid host and domain name for the Dynamic DNS service on WAN3';
    var errMsgL10n8 = 'Please specify a valid user/account name for the Dynamic DNS service on WAN3';
    var errMsgL10n9 = 'Please specify a valid password for the Dynamic DNS service on WAN3';    
    var errMsgL10n10 = 'Please specify a valid host and domain name for the Dynamic DNS service on WAN4';
    var errMsgL10n11 = 'Please specify a valid user/account name for the Dynamic DNS service on WAN4';
    var errMsgL10n12 = 'Please specify a valid password for the Dynamic DNS service on WAN4';    
                
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtWan1DDNSDomainName," + errMsgL10n1;
    txtFieldIdArr[1] = "txtWan1DDNSUsrName," + errMsgL10n2;
    txtFieldIdArr[2] = "txtWan1DDNSPasswd," + errMsgL10n3;
    txtFieldIdArr[3] = "txtWan2DDNSDomainName," + errMsgL10n4;
    txtFieldIdArr[4] = "txtWan2DDNSUsrName," + errMsgL10n5;
    txtFieldIdArr[5] = "txtWan2DDNSPasswd," + errMsgL10n6;
    txtFieldIdArr[6] = "txtWan3DDNSDomainName," + errMsgL10n7;
    txtFieldIdArr[7] = "txtWan3DDNSUsrName," + errMsgL10n8;
    txtFieldIdArr[8] = "txtWan3DDNSPasswd," + errMsgL10n9;
    txtFieldIdArr[9] = "txtWan4DDNSDomainName," + errMsgL10n10;
    txtFieldIdArr[10] = "txtWan4DDNSUsrName," + errMsgL10n11;
    txtFieldIdArr[11] = "txtWan4DDNSPasswd," + errMsgL10n12;
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;    
    if(!validateFQDN("txtWan1DDNSDomainName"))
        return false;
    if(!validateFQDN("txtWan2DDNSDomainName"))
        return false;
    if(!validateFQDN("txtWan3DDNSDomainName"))
        return false;
    if(!validateFQDN("txtWan4DDNSDomainName"))
        return false;
    return true;
    }
    
function orayInit ()
    {
    var noOfWansVal = document.getElementById ('hdNoOfWans').value;
    orayLoad (noOfWansVal);        
    }

function orayLoad (noOfWans)
    {    
    var request = null;                    
    try
        { // Firefox, Opera 8.0+, Safari
            request=new XMLHttpRequest();
        }
    catch (e)
        { // Internet Explorer
            try
                {
                request=new ActiveXObject("Msxml2.XMLHTTP");
                }
                catch (e)
                    {
                    try
                       {
                       request=new ActiveXObject("Microsoft.XMLHTTP");
                       }
                   catch (e)
                       {
                       window.status = "Your browser does not support AJAX!";
                       return false;
                       }
                       }
           }
    request.onreadystatechange = function()    
        {                
        if (request.readyState == 4)                
            {                    
            var responseString = request.responseText;
            var resArr = responseString.split ("&&"); 
            for (i = 1; i <= noOfWans; i++)
                {
                var td1Obj1 = document.getElementById ('wan' + i + 'td1');
                var td1Obj2 = document.getElementById ('wan' + i + 'td2');
                var td1Obj3 = document.getElementById ('wan' + i + 'td3');
                var innerResArr = resArr[i-1].split ("||");
                if (td1Obj1) td1Obj1.innerHTML = innerResArr[0];
                if (td1Obj2) td1Obj2.innerHTML = innerResArr[1];
                if (td1Obj3) td1Obj3.innerHTML = innerResArr[2];
                }
            }
        }
        request.open ("GET", "?page=getOrayStatus.htm&wanNo=" + noOfWans + "&time=" + new Date(), true);
        request.send (null);
        var t = setTimeout("orayInit ()", 5000);        
    }
