/* lan_dmz_ipv6.js - API library for LAN DMZ IPv6 configuration */

/* Copyright 2011 TeamF1, Inc. */

/*
modification history 
------------------------
01a,18thAUG11,mvb  written. 
*/

/* add_ld_in_service_IPv6.htm Start */
function fwAddLdInServicesValidate()
    {    
    
    if (ipv6Validate ('addLDInLanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addLDInLanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addLDInLanUserStart','addLDInLanUserFinish') == false)
		return false;
    
	if (ipv6Validate ('addLDInWanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addLDInWanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addLDInWanUserStart','addLDInWanUserFinish') == false)
		return false;
    	
    return true;
    }
    
function fwActionCheckLD ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHEDULE":
        case "DROP_BY_SCHEDULE":
			fieldStateChangeWr ('','','selSchedule','');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','','');
			break;
		default:
			fieldStateChangeWr ('selSchedule','','','');
			break;
		}
	}
function dropFieldSelectLanLD (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addLDInLanUserFinish', '', 'addLDInLanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addLDInLanUserStart addLDInLanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addLDInLanUserStart addLDInLanUserFinish', '', '', '');
   			break;
   		}
	}
function dropFieldSelectWanLD (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addLDInWanUserFinish', '', 'addLDInWanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addLDInWanUserStart addLDInWanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addLDInWanUserStart addLDInWanUserFinish', '', '', '');
   			break;
   		}
    }
function InitialSettingsLD ()
	{
	fwActionCheckLD ();
	var fldObj = document.getElementById('addLDInLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLanLD (fldObj);
	var fldObj = document.getElementById('addLDInDmzUser');
	if (!(fldObj.disable))
		dropFieldSelectWanLD (fldObj);
	}
	
/* add_ld_in_service_IPv6.htm End */

/* add_ld_out_service_IPv6.htm Start */
function fwAddLdOutServicesValidate()
    {
    
    if (ipv6Validate ('addLDOutLanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addLDOutLanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addLDOutLanUserStart','addLDOutLanUserFinish') == false)
		return false;

	if (ipv6Validate ('addLDOutWanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addLDOutWanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addLDOutWanUserStart','addLDOutWanUserFinish') == false)
		return false;

    return true;
    }
function fwActionCheck ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHEDULE":
        case "DROP_BY_SCHEDULE":
			fieldStateChangeWr ('','','selSchedule','');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','','');
			break;
		default:
			fieldStateChangeWr ('selSchedule','','','');
			break;
		}
	}
function dropFieldSelectLan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addLDOutLanUserFinish', '', 'addLDOutLanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addLDOutLanUserStart addLDOutLanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addLDOutLanUserStart addLDOutLanUserFinish', '', '', '');
   			break;
   		}
	}
function dropFieldSelectWan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addLDOutWanUserFinish', '', 'addLDOutWanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addLDOutWanUserStart addLDOutWanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addLDOutWanUserStart addLDOutWanUserFinish', '', '', '');
   			break;
   		}
    }
    
function InitialSettings ()
	{
	fwActionCheck ();
	var fldObj = document.getElementById('addLDOutLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLan (fldObj);
	var fldObj = document.getElementById('addDWOutDmzUser');
	if (!(fldObj.disable))
		dropFieldSelectWan (fldObj);
	}
/* add_ld_out_service_IPv6.htm End */
