/* wanIpv6.js - API library for wan Ipv6 setting configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,30SEP10,mvb  written. 
*/



function wanSetupValidate ()
{
	var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "tblWi1IpAddr,Please enter a valid IPv6 Address";
    txtFieldIdArr[1] = "txtPreLen,Please enter a valid Prefix Length";
    txtFieldIdArr[2] = "tblWi1IpGway,Please enter a valid IPv6 Gateway Address";
    txtFieldIdArr[3] = "tblWi1DNSPrimary,Please enter a valid Primary DNS Server";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        return false;
        
    if (ipv6Validate ('tblWi1IpAddr', true, true, '') == false)
	    return false;
	    
	var preLenObj = document.getElementById ('txtPreLen');
	if (numericValueRangeCheck (preLenObj, '', '', 0, 128, true, '', '') == false)
		return false;
		
	if (ipv6Validate ('tblWi1IpGway', true, true, '') == false)
	    return false;
	    
	if (ipv6Validate ('tblWi1DNSPrimary', true, true, '') == false)
	    return false;
	
	if (ipv6Validate ('tblWi1DNSSec', true, true, '') == false)
	    return false;
	
    var ppoEtxtFieldIdArr = new Array ();
    ppoEtxtFieldIdArr[0] = "txtPPPoEUserName,Please enter username";
    ppoEtxtFieldIdArr[1] = "txtPPPoEPassword,Please enter password";
    ppoEtxtFieldIdArr[2] = "tblPPPoEPrimaryDns,Please enter a valid Primary DNS Server";
 //   ppoEtxtFieldIdArr[3] = "tblPPPoESecDns,Please enter a valid Secondary DNS Server";
    if (txtFieldArrayCheck (ppoEtxtFieldIdArr) == false)
        return false;
    
    if (ipv6Validate ('tblPPPoEPrimaryDns', true, true, '') == false)
        return false;

    if (ipv6Validate ('tblPPPoESecDns', true, true, '') == false)
        return false;

	return true;
}

function ipAddrCheck ()
	{
	var selValue = comboSelectedValueGet ('selISPType');
	if (!selValue) return;
	switch (selValue)
		{
		case 'ifStatic6':	/* Use Static IP Address */
            fieldStateChangeWr ('','tblDhcpv6Section tblPppoeIpv6Section','','tblWi1IpAddrSection');
			break;
        case 'pppoe6':    /* Use PPPoE */
            fieldStateChangeWr ('','tblDhcpv6Section tblWi1IpAddrSection','','tblPppoeIpv6Section');
            pppoeDHCPv6OptionCheck ();
           break;
		case 'dhcp6c':	/* Get Dynamically from ISP */
		default:
            fieldStateChangeWr ('','tblWi1IpAddrSection tblPppoeIpv6Section','','tblDhcpv6Section');
			break;
		}
	}

function wanIpv6Init ()
    {
    enableCheck ();
    ipAddrCheck ();
    prefixDelegationCheck ();
    }

function prefixDelegationCheck ()
    {
    var rdbSelectVal = radioCheckedValueGet('dhcpv6c.statelessMode');
    if(parseInt(rdbSelectVal, 10) == 1)
        fieldStateChangeWr ('','','chkbPrefixDeleGation','');
    else
        fieldStateChangeWr ('chkbPrefixDeleGation','','','');
    }

function pppoeDHCPv6OptionCheck ()
    {
    var seldhcpv6Value = comboSelectedValueGet ('selDHCPv6Type');
    if (!seldhcpv6Value) return;
    switch (parseInt(seldhcpv6Value, 10))
        {
        case 0: /* Disable DHCPv6 case */
            fieldStateChangeWr ('','','tblPPPoEPrimaryDns tblPPPoESecDns','');
            break;
        default:
            fieldStateChangeWr ('tblPPPoEPrimaryDns tblPPPoESecDns','','','');
            break;
        }
    }
